*     SGP4  SGP4 PREDICTION   (STANDALONE SGP4/SGP44)  15OCT90
                                                                            
      SUBROUTINE SGP4(IER)                                                  
                                                                            
************************************************************************    
*                                                                      *    
*     SGP4 (SPADOC COMPATIBLE) PREDICITION MODEL FROM SPACETRACK       *    
*     REPORT #__.  THIS IS AN UPDATED VERSION OF SGP4 AND SDP4, WHICH  *    
*     WERE ORIGINALLY PUBLISHED SEPARATELY IN SPACETRACK REPORT #3.    *    
*                                                                      *    
*     INIT = 0   DO PREDICTION ONLY                                    *    
*     INIT = 1   INITIALIZE AND PREDICT                                *    
*                                                                      *    
*     ERROR RETURNS                                                    *    
*                                                                      *    
*            IER = 0    NO ERRORS                                      *    
*            IER = 1    ECC OR MEAN MOTION OUT OF BOUNDS               *    
*                                                                      *    
************************************************************************    
                                                                            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                                   
      save  !required for IRIX compilers
                                                                            
      INTEGER YR                                                            
      INTEGER*4 SATN                                                        
                                                                            
      COMMON/CONST/C1,C1P2P,PI,PIO2,QZMS2T,RPTIM,SS,THGR70,TWOPI,X2O3,      
     1       X3PIO2,XJ2,XJ3,XJ4,XKE,XKMPER,XJ3OJ2                           
      COMMON/ELT/R,TC,X,Y,Z,XDOT,YDOT,ZDOT                                  
      COMMON/ELTM/AM,EM,XINCM,XNODEM,OMEGAM,XMAM,CNODM,CON49,COSIM,         
     1       COSOMM,EMSQ,RTEMSQ,SINIM,SINOMM,SNODM,XN                       
      COMMON/EPELM/AO,EO,XINCO,XNODEO,OMEGAO,XMAO,AINV,BSTAR,CNDOT,         
     1       CON41,CON42,COSIO,COSIO2,EINV,EOSQ,EPOCH,OMEOSQ,          
     2       OMGDT,POSQ,QO,RTEOSQ,SINIO,T,THGRO,XMDOT,XNDOT,         
     3       XNO,XNODOT,XPIDOT,SATN,YR,init,method
************************************************************************    
                                                                            
*     SET MATHEMATICAL CONSTANTS  *                                         
                                                                            
      PIO2=1.570796326794897D0                                              
      X3PIO2=4.712388980384690D0                                            
      PI=3.14159265358979D0                                                 
      TWOPI=6.283185307179586D0                                             
      DE2RA=1.745329251994330D-2                                            
      X2O3=2.D0/3.D0                                                        
                                                                            
*     SET PHYSICAL CONSTANTS  *                                             
                                                                            
*     FK5 CONSTANT VALUE  *                                                 
      C1=1.72027916940703639D-2                                             
      C1P2P=C1+TWOPI                                                        
      THGR70=1.7321343856509374D0                                           
*     WGS-72 EARTH CONSTANTS *                                              
      XKE=7.43669161331734132D-2                                            
      XKMPER=6378.135D0                                                     
      XPDOTP=229.1831180523293D0                                            
      RPTIM=4.37526908801129966D-3                                          
      XJ2=1.082616D-3                                                       
      XJ3=-2.53881D-6                                                       
      XJ4=-1.65597D-6                                                       
      XJ3OJ2=XJ3/XJ2                                                        
*     OTHER CONSTANTS *                                                     
      XMNPDA=1440.D0                                                        
      SS=78.D0/XKMPER+1.D0                                                  
      QZMS2T=((120.D0-78.D0)/XKMPER)**4                                     
*     CLEAR SGP4 ERROR FLAG *                                               
      IER=0                                                                 
                                                                            
      IF(INIT .EQ. 0) GO TO 100                                             
                                                                            
*     INITIALIZATION                                                        
                                                                            
      CALL INITL                                                            
      IF(OMEOSQ .LT. 0.D0 .OR. XNO .LT. 0.D0) GO TO 700                     
      ISIMP=0                                                               
      IF(QO .LT. (220.D0/XKMPER+1.D0)) ISIMP=1                              
      S4=SS                                                                 
      QZMS24=QZMS2T                                                         
      PERIGE=(QO-1.D0)*XKMPER                                               
      IF(PERIGE .GE. 156.D0) GO TO 40                                       
      S4=PERIGE-78.D0                                                       
      IF(PERIGE .GT. 98.D0) GO TO 30                                        
      S4=20.D0                                                              
   30 QZMS24=((120.D0-S4)/XKMPER)**4                                        
      S4=S4/XKMPER+1.D0                                                     
   40 PINVSQ=1.D0/POSQ                                                      
      TSI=1.D0/(AO-S4)                                                      
      ETA=AO*EO*TSI                                                         
      ETASQ=ETA*ETA                                                         
      EETA=EO*ETA                                                           
      PSISQ=ABS(1.D0-ETASQ)                                                 
      COEF=QZMS24*TSI**4                                                    
      COEF1=COEF/PSISQ**3.5D0                                               
      CC2=COEF1*XNO*(AO*(1.D0+1.5D0*ETASQ+EETA*(4.D0+ETASQ))+.375D0*        
     1       XJ2*TSI/PSISQ*CON41*(8.D0+3.D0*ETASQ*(8.D0+ETASQ)))            
      CC1=BSTAR*CC2                                                         
      CC3=0.D0                                                              
      IF(EO .GT. 1.D-4) CC3=-2.D0*COEF*TSI*XJ3OJ2*XNO*SINIO/EO              
      X1MTH2=1.D0-COSIO2                                                    
      CC4=2.D0*XNO*COEF1*AO*OMEOSQ*(ETA*(2.D0+.5D0*ETASQ)+EO*(.5D0+         
     1       2.D0*ETASQ)-XJ2*TSI/(AO*PSISQ)*(-3.D0*CON41*(1.D0-2.D0*        
     2       EETA+ETASQ*(1.5D0-.5D0*EETA))+.75D0*X1MTH2*(2.D0*ETASQ         
     3       -EETA*(1.D0+ETASQ))*COS(2.D0*OMEGAO)))                         
      CC5=2.D0*COEF1*AO*OMEOSQ*(1.D0+2.75D0*(ETASQ+EETA)+EETA*ETASQ)        
      COSIO4=COSIO2*COSIO2                                                  
      TEMP1=1.5D0*XJ2*PINVSQ*XNO                                            
      TEMP2=.5D0*TEMP1*XJ2*PINVSQ                                           
      TEMP3=-.46875D0*XJ4*PINVSQ*PINVSQ*XNO                                 
      XMDOT=XNO+.5D0*TEMP1*RTEOSQ*CON41+.0625D0*TEMP2*RTEOSQ*(13.D0         
     1       -78.D0*COSIO2+137.D0*COSIO4)                                   
      OMGDT=-.5D0*TEMP1*CON42+.0625D0*TEMP2*(7.D0-114.D0*COSIO2+            
     1       395.D0*COSIO4)+TEMP3*(3.D0-36.D0*COSIO2+49.D0*COSIO4)          
      XHDOT1=-TEMP1*COSIO                                                   
      XNODOT=XHDOT1+(.5D0*TEMP2*(4.D0-19.D0*COSIO2)+2.D0*TEMP3*(3.D0        
     1       -7.D0*COSIO2))*COSIO                                           
      XPIDOT=OMGDT+XNODOT                                                   
      OMGCOF=BSTAR*CC3*COS(OMEGAO)                                          
      XMCOF=0.D0                                                            
      IF(EO .GT. 1.D-4) XMCOF=-X2O3*COEF*BSTAR/EETA                         
      XNODCF=3.5D0*OMEOSQ*XHDOT1*CC1                                        
      T2COF=1.5D0*CC1                                                       
      XLCOF=-.25D0*XJ3OJ2*SINIO*(3.D0+5.D0*COSIO)/(1.D0+COSIO)              
      AYCOF=-.5D0*XJ3OJ2*SINIO                                              
      DELMO=(1.D0+ETA*COS(XMAO))**3                                         
      SINMAO=SIN(XMAO)                                                      
      X7THM1=7.D0*COSIO2-1.D0                                               
      IF((TWOPI/XNO) .LT. 225.D0) GO TO 80                                  
      METHOD=2                                                              
      ISIMP=1                                                               
      INITDS=0                                                              
      TC=0.D0                                                               
      XINCM=XINCO                                                           
      XNP=XNO             !  THE NEXT SIX LINES WERE ADDED FOR V3.01        
      EP=EO                                                                 
      XINCP=XINCO                                                           
      XNODEP=XNODEO                                                         
      OMEGAP=OMEGAO                                                         
      XMAP=XMAO                                                             
      CALL DPPER(XNP,EP,XINCP,XNODEP,OMEGAP,XMAP,INITDS)   ! V3.01          
      XNO=XNP             !  THE NEXT SIX LINES WERE ADDED FOR V3.01        
      EO=EP                                                                 
      XINCO=XINCP                                                           
      XNODEO=XNODEP                                                         
      OMEGAO=OMEGAP                                                         
      XMAO=XMAP                                                             
      IF(EO .LT. 0.D0 .OR. EO .GT. 1.D0) GO TO 700                          
      CALL DSPACE(DNDT,DEDT,DIDT,DNODT,DOMDT,DMDT,INITDS)                   
   80 IF(ISIMP .EQ. 1) GO TO 90                                             
      CC1SQ=CC1*CC1                                                         
      D2=4.D0*AO*TSI*CC1SQ                                                  
      TEMP=D2*TSI*CC1/3.D0                                                  
      D3=(17.D0*AO+S4)*TEMP                                                 
      D4=.5D0*TEMP*AO*TSI*(221.D0*AO+31.D0*S4)*CC1                          
      T3COF=D2+2.D0*CC1SQ                                                   
      T4COF=.25D0*(3.D0*D3+CC1*(12.D0*D2+10.D0*CC1SQ))                      
      T5COF=.2D0*(3.D0*D4+12.D0*CC1*D3+6.D0*D2*D2+15.D0*CC1SQ*(2.D0         
     1       *D2+CC1SQ))                                                    
   90 INIT=0                                                                
                                                                            
*     UPDATE FOR SECULAR GRAVITY AND ATMOSPHERIC DRAG                       
                                                                            
  100 XMDF=XMAO+XMDOT*T                                                     
      OMGADF=OMEGAO+OMGDT*T                                                 
      XNODDF=XNODEO+XNODOT*T                                                
      OMEGAM=OMGADF                                                         
      XMAM=XMDF                                                             
      T2=T*T                                                                
      XNODEM=XNODDF+XNODCF*T2                                               
      TEMPA=1.D0-CC1*T                                                      
      TEMPE=BSTAR*CC4*T                                                     
      TEMPL=T2COF*T2                                                        
      IF(ISIMP .EQ. 1) GO TO 110                                            
      DELOMG=OMGCOF*T                                                       
      DELM=XMCOF*((1.D0+ETA*COS(XMDF))**3-DELMO)                            
      TEMP=DELOMG+DELM                                                      
      XMAM=XMDF+TEMP                                                        
      OMEGAM=OMGADF-TEMP                                                    
      T3=T2*T                                                               
      T4=T3*T                                                               
      TEMPA=TEMPA-D2*T2-D3*T3-D4*T4                                         
      TEMPE=TEMPE+BSTAR*CC5*(SIN(XMAM)-SINMAO)                              
      TEMPL=TEMPL+T3COF*T3+T4*(T4COF+T*T5COF)                               
  110 XN=XNO                                                                
      EM=EO                                                                 
      XINCM=XINCO                                                           
      IF(METHOD .EQ. 2) THEN                                                
             TC=T                                                           
             INITDS=INITDS+1                                                
             CALL DSPACE(DNDT,DEDT,DIDT,DNODT,DOMDT,DMDT,INITDS)            
      END IF                                                                
      IF(XN .LE. 0.D0) GO TO 700                                            
      AM=(XKE/XN)**X2O3*TEMPA**2                                            
      XN=XKE/AM**1.5D0                                                      
      EM=EM-TEMPE                                                           
      IF(EM .GE. 1.D0) GO TO 700                                            
C     IF(EM .LT. 0.D0) GO TO 700       ! DELETED FOR V3.01                  
      IF(EM .LT. -1.D-3) GO TO 700     ! ADDED FOR V3.01                    
C     IF(EM .LT. 1.D-6) EM=1.D-6       ! DELETED FOR V3.01                  
      IF(EM .LT. 0.D0) EM=1.D-6        ! ADDED FOR V3.01                    
      XMAM=XMAM+XNO*TEMPL                                                   
      XLM=XMAM+OMEGAM+XNODEM                                                
      EMSQ=EM*EM                                                            
      TEMP=1.D0-EMSQ                                                        
      RTEMSQ=SQRT(TEMP)                                                     
      XNODEM=FMOD2P(XNODEM)                                                 
      OMEGAM=FMOD2P(OMEGAM)                                                 
      XLM=FMOD2P(XLM)                                                       
      XMAM=FMOD2P(XLM-OMEGAM-XNODEM)                                        
                                                                            
*     COMPUTE EXTRA MEAN QUANTITIES                                         
                                                                            
      SINIM=SIN(XINCM)                                                      
      COSIM=COS(XINCM)                                                      
      SINOMM=SIN(OMEGAM)                                                    
      COSOMM=COS(OMEGAM)                                                    
                                                                            
*     ADD LUNAR-SOLAR PERIODICS                                             
                                                                            
      XNP=XN                                                                
      EP=EM                                                                 
      XINCP=XINCM                                                           
      OMEGAP=OMEGAM                                                         
      XNODEP=XNODEM                                                         
      XMAP=XMAM                                                             
      SINIP=SINIM                                                           
      COSIP=COSIM                                                           
      IF(METHOD .EQ. 2) THEN                                                
             CALL DPPER(XNP,EP,XINCP,XNODEP,OMEGAP,XMAP,INITDS)             
             IF(XINCP .LT. 0.D0) THEN                                       
                    XINCP=-XINCP                                            
                    XNODEP=XNODEP+PI                                        
                    OMEGAP=OMEGAP-PI                                        
             END IF                                                         
             IF(EP .LT. 0.D0 .OR. EP .GT. 1.D0) GO TO 700                   
      END IF                                                                
                                                                            
*     LONG PERIOD PERIODICS                                                 
                                                                            
      IF(METHOD .EQ. 2) THEN                                                
             SINIP=SIN(XINCP)                                               
             COSIP=COS(XINCP)                                               
             AYCOF=-.5D0*XJ3OJ2*SINIP                                       
             XLCOF=-.25D0*XJ3OJ2*SINIP*(3.D0+5.D0*COSIP)/(1.D0+COSIP)       
      END IF                                                                
      AXNL=EP*COS(OMEGAP)                                                   
      TEMP=1.D0/(AM*(1.D0-EP*EP))                                           
      AYNL=EP*SIN(OMEGAP)+TEMP*AYCOF                                        
      XL=XMAP+OMEGAP+XNODEP+TEMP*XLCOF*AXNL                                 
                                                                            
*     SOLVE KEPLER'S EQUATION                                               
                                                                            
      U=FMOD2P(XL-XNODEP)                                                   
      EO1=U                                                                 
  120 SINEO1=SIN(EO1)                                                       
      COSEO1=COS(EO1)                                                       
      TEM5=1.D0-COSEO1*AXNL-SINEO1*AYNL                                     
      TEM5=(U-AYNL*COSEO1+AXNL*SINEO1-EO1)/TEM5                             
      IF(DABS(TEM5) .LT. 1.D-12) GO TO 130                                  
      EO1=EO1+TEM5                                                          
      GO TO 120                                                             
                                                                            
*     SHORT PERIOD PRELIMINARY QUANTITIES                                   
                                                                            
  130 ECOSE=AXNL*COSEO1+AYNL*SINEO1                                         
      ESINE=AXNL*SINEO1-AYNL*COSEO1                                         
      EL2=AXNL*AXNL+AYNL*AYNL                                               
      PL=AM*(1.D0-EL2)                                                      
      IF ( PL .LT. 0.D0 ) GO TO 700                                         
      RL=AM*(1.D0-ECOSE)                                                    
      RDOTL=SQRT(AM)*ESINE/RL                                               
      RVDOTL=SQRT(PL)/RL                                                    
      BETAL=SQRT(1.D0-EL2)                                                  
      TEMP=ESINE/(1.D0+BETAL)                                               
      SINU=AM/RL*(SINEO1-AYNL-AXNL*TEMP)                                    
      COSU=AM/RL*(COSEO1-AXNL+AYNL*TEMP)                                    
      SU=ACTAN(SINU,COSU)                                                   
      SIN2U=(COSU+COSU)*SINU                                                
      COS2U=1.D0-2.D0*SINU*SINU                                             
      TEMP=1.D0/PL                                                          
      TEMP1=.5D0*XJ2*TEMP                                                   
      TEMP2=TEMP1*TEMP                                                      
                                                                            
*     UPDATE FOR SHORT PERIOD PERIODICS                                     
                                                                            
      IF(METHOD .EQ. 2) THEN                                                
             COSISQ=COSIP*COSIP                                             
             CON41=3.D0*COSISQ-1.D0                                         
             X1MTH2=1.D0-COSISQ                                             
             X7THM1=7.D0*COSISQ-1.D0                                        
      END IF                                                                
      R=RL*(1.D0-1.5D0*TEMP2*BETAL*CON41)+.5D0*TEMP1*X1MTH2*COS2U           
      SU=SU-.25D0*TEMP2*X7THM1*SIN2U                                        
      XNODE=XNODEP+1.5D0*TEMP2*COSIP*SIN2U                                  
      XINC=XINCP+1.5D0*TEMP2*COSIP*SINIP*COS2U                              
      RDOT=RDOTL-XN*TEMP1*X1MTH2*SIN2U/XKE                                  
      RVDOT=RVDOTL+XN*TEMP1*(X1MTH2*COS2U+1.5D0*CON41)/XKE                  
                                                                            
*     ORIENTATION VECTORS                                                   
                                                                            
      SINSU=SIN(SU)                                                         
      COSSU=COS(SU)                                                         
      SNOD=SIN(XNODE)                                                       
      CNOD=COS(XNODE)                                                       
      SINI=SIN(XINC)                                                        
      COSI=COS(XINC)                                                        
      XMX=-SNOD*COSI                                                        
      XMY=CNOD*COSI                                                         
      UX=XMX*SINSU+CNOD*COSSU                                               
      UY=XMY*SINSU+SNOD*COSSU                                               
      UZ=SINI*SINSU                                                         
      VX=XMX*COSSU-CNOD*SINSU                                               
      VY=XMY*COSSU-SNOD*SINSU                                               
      VZ=SINI*COSSU                                                         
                                                                            
*     POSITION AND VELOCITY                                                 
                                                                            
      X=R*UX                                                                
      Y=R*UY                                                                
      Z=R*UZ                                                                
      XDOT=RDOT*UX+RVDOT*VX                                                 
      YDOT=RDOT*UY+RVDOT*VY                                                 
      ZDOT=RDOT*UZ+RVDOT*VZ                                                 
      GO TO 999                                                             
                                                                            
*     ERROR PROCESSING                                                      
                                                                            
  700 IER=1                                                                 
                                                                            
  999 RETURN                                                                
                                                                            
      END                                                                   
*     TWO-ARGUMENT ARCTANGENT 0-2 PI(STANDALONE SGP4/ACTAN4) 19SEP90
                                                                            
      FUNCTION ACTAN(SINX,COSX)                                             
                                                                            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                                   
                                                                            
      COMMON/CONST/C1,C1P2P,PI,PIO2,QZMS2T,RPTIM,SS,THGR70,TWOPI,X2O3,      
     1       X3PIO2,XJ2,XJ3,XJ4,XKE,XKMPER,XJ3OJ2                           
                                                                            
      ACTAN=0.D0                                                            
      IF (COSX.EQ.0.D0  ) GO TO 5                                           
      IF (COSX.GT.0.D0  ) GO TO 1                                           
      ACTAN=PI                                                              
      GO TO 7                                                               
    1 IF (SINX.EQ.0.D0  ) GO TO 8                                           
      IF (SINX.GT.0.D0  ) GO TO 7                                           
      ACTAN=TWOPI                                                           
      GO TO 7                                                               
    5 IF (SINX.EQ.0.D0  ) GO TO 8                                           
       IF (SINX.GT.0.D0  ) GO TO 6                                          
      ACTAN=X3PIO2                                                          
      GO TO 8                                                               
    6 ACTAN=PIO2                                                            
      GO TO 8                                                               
    7 TEMP=SINX/COSX                                                        
      ACTAN=ACTAN+ATAN(TEMP)                                                
    8 RETURN                                                                
      END                                                                   
*      DPPER DSPACE PERIODICS  (STANDALONE SGP4 DC/DPPER4)  20APR90         
                                                                            
      SUBROUTINE DPPER(XNP,EP,XIP,XNODEP,OMEGAP,XMAP,INITDS)                
                                                                            
*-----------------------------------------------------------------------    
*     THIS SUBROUTINE PROVIDES DEEP SPACE LONG PERIOD PERIODIC CONTRIBU-    
*     TIONS TO THE MEAN ELEMENTS. BY DESIGN THESE PERIODICS ARE ZERO        
*     AT EPOCH.                                                             
*-----------------------------------------------------------------------    
                                                                            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                                   
      save  !required for IRIX compilers
                                                                            
      INTEGER YR                                                            
      INTEGER*4 SATN                                                        
                                                                            
      COMMON/CONST/C1,C1P2P,PI,PIO2,QZMS2T,RPTIM,SS,THGR70,TWOPI,X2O3,      
     1       X3PIO2,XJ2,XJ3,XJ4,XKE,XKMPER,XJ3OJ2                           
      COMMON/ELTM/AM,EM,XINCM,XNODEM,OMEGAM,XMAM,CNODM,CON49,COSIM,         
     1       COSOMM,EMSQ,RTEMSQ,SINIM,SINOMM,SNODM,XN                       
      COMMON/EPELM/AO,EO,XINCO,XNODEO,OMEGAO,XMAO,AINV,BSTAR,CNDOT,         
     1       CON41,CON42,COSIO,COSIO2,EINV,EOSQ,EPOCH,OMEOSQ,          
     2       OMGDT,POSQ,QO,RTEOSQ,SINIO,T,THGRO,XMDOT,XNDOT,         
     3       XNO,XNODOT,XPIDOT,SATN,YR,init,method
************************************************************************    
                                                                            
      COMMON/LSCOM/S1,S2,S3,S4,S5,S6,S7,Z1,Z2,Z3,Z11,Z12,Z13,Z21,Z22,       
     1             Z23,Z31,Z32,Z33,SS1,SS2,SS3,SS4,SS5,SS6,SS7,SZ1,SZ2,     
     2             SZ3,SZ11,SZ12,SZ13,SZ21,SZ22,SZ23,SZ31,SZ32,SZ33,        
     3             DAY,GAM                                                  
                                                                            
      DATA              ZNS,             ZES/                               
     1                  1.19459D-5,      .01675D0/                          
      DATA              ZNL,            ZEL/                                
     1                  1.5835218D-4,    .05490D0/                          
                                                                            
      IF(INITDS .GT. 0) GO TO 40                                            
                                                                            
*     DEEP SPACE PERIODICS INITIALIZATION                                   
                                                                            
      XN=XNP                                                                
      EM=EP                                                                 
      SNODM=SIN(XNODEP)                                                     
      CNODM=COS(XNODEP)                                                     
      SINOMM=SIN(OMEGAP)                                                    
      COSOMM=COS(OMEGAP)                                                    
      SINIM=SIN(XIP)                                                        
      COSIM=COS(XIP)                                                        
                                                                            
*     INITIALIZE LUNAR SOLAR TERMS                                          
                                                                            
      CALL DSCOM                                                            
      ZMOL=FMOD2P(4.7199672D0+.22997150D0*DAY-GAM)                          
      ZMOS=FMOD2P(6.2565837D0+.017201977D0*DAY)                             
                                                                            
*     DO SOLAR TERMS                                                        
                                                                            
      SE2=2.D0*SS1*SS6                                                      
      SE3=2.D0*SS1*SS7                                                      
      SI2=2.D0*SS2*SZ12                                                     
      SI3=2.D0*SS2*(SZ13-SZ11)                                              
      SL2=-2.D0*SS3*SZ2                                                     
      SL3=-2.D0*SS3*(SZ3-SZ1)                                               
      SL4=-2.D0*SS3*(-21.D0-9.D0*EMSQ)*ZES                                  
      SGH2=2.D0*SS4*SZ32                                                    
      SGH3=2.D0*SS4*(SZ33-SZ31)                                             
      SGH4=-18.D0*SS4*ZES                                                   
      SH2=-2.D0*SS2*SZ22                                                    
      SH3=-2.D0*SS2*(SZ23-SZ21)                                             
                                                                            
*     DO LUNAR TERMS                                                        
                                                                            
      EE2=2.D0*S1*S6                                                        
      E3=2.D0*S1*S7                                                         
      XI2=2.D0*S2*Z12                                                       
      XI3=2.D0*S2*(Z13-Z11)                                                 
      XL2=-2.D0*S3*Z2                                                       
      XL3=-2.D0*S3*(Z3-Z1)                                                  
      XL4=-2.D0*S3*(-21.D0-9.D0*EMSQ)*ZEL                                   
      XGH2=2.D0*S4*Z32                                                      
      XGH3=2.D0*S4*(Z33-Z31)                                                
      XGH4=-18.D0*S4*ZEL                                                    
      XH2=-2.D0*S2*Z22                                                      
      XH3=-2.D0*S2*(Z23-Z21)                                                
                                                                            
*     CALCULATE TIME VARYING PERIODICS                                      
                                                                            
   40 ZM=ZMOS+ZNS*T                                                         
      IF(INIT .NE. 0) ZM=ZMOS                                               
      ZF=ZM+2.D0*ZES*SIN (ZM)                                               
      SINZF=SIN (ZF)                                                        
      F2=.5D0*SINZF*SINZF-.25D0                                             
      F3=-.5D0*SINZF*COS (ZF)                                               
      SES=SE2*F2+SE3*F3                                                     
      SIS=SI2*F2+SI3*F3                                                     
      SLS=SL2*F2+SL3*F3+SL4*SINZF                                           
      SGHS=SGH2*F2+SGH3*F3+SGH4*SINZF                                       
      SHS=SH2*F2+SH3*F3                                                     
      ZM=ZMOL+ZNL*T                                                         
      IF(INIT .NE. 0) ZM=ZMOL                                               
      ZF=ZM+2.D0*ZEL*SIN (ZM)                                               
      SINZF=SIN (ZF)                                                        
      F2=.5D0*SINZF*SINZF-.25D0                                             
      F3=-.5D0*SINZF*COS (ZF)                                               
      SEL=EE2*F2+E3*F3                                                      
      SIL=XI2*F2+XI3*F3                                                     
      SLL=XL2*F2+XL3*F3+XL4*SINZF                                           
      SGHL=XGH2*F2+XGH3*F3+XGH4*SINZF                                       
      SHL=XH2*F2+XH3*F3                                                     
      PE=SES+SEL                                                            
      PINC=SIS+SIL                                                          
      PL=SLS+SLL                                                            
      PGH=SGHS+SGHL                                                         
      PH=SHS+SHL                                                            
      IF(INIT .EQ. 0) GO TO 200                                             
      PEO=0.D0                                                              
      PINCO=0.D0                                                            
      PLO=0.D0                                                              
      PGHO=0.D0                                                             
      PHO=0.D0                                                              
      RETURN                                                                
  200 PE=PE-PEO                                                             
      PINC=PINC-PINCO                                                       
      PL=PL-PLO                                                             
      PGH=PGH-PGHO                                                          
      PH=PH-PHO                                                             
      XIP = XIP+PINC                                                        
      EP = EP+PE                                                            
      SINIP=SIN(XIP)                                                        
      COSIP=COS(XIP)                                                        
      IF(XIP.LT.(.2D0)) GO TO 220                                           
                                                                            
*     APPLY PERIODICS DIRECTLY                                              
                                                                            
      PH=PH/SINIP                                                           
      PGH=PGH-COSIP*PH                                                      
      OMEGAP=OMEGAP+PGH                                                     
      XNODEP=XNODEP+PH                                                      
      XMAP=XMAP+PL                                                          
      RETURN                                                                
                                                                            
*     APPLY PERIODICS WITH LYDDANE MODIFICATION                             
                                                                            
  220 SINOP=SIN(XNODEP)                                                     
      COSOP=COS(XNODEP)                                                     
      ALFDP=SINIP*SINOP                                                     
      BETDP=SINIP*COSOP                                                     
      DALF=PH*COSOP+PINC*COSIP*SINOP                                        
      DBET=-PH*SINOP+PINC*COSIP*COSOP                                       
      ALFDP=ALFDP+DALF                                                      
      BETDP=BETDP+DBET                                                      
      XNODEP=FMOD2P(XNODEP)                                                 
      XLS = XMAP+OMEGAP+COSIP*XNODEP                                        
      DLS=PL+PGH-PINC*XNODEP*SINIP                                          
      XLS=XLS+DLS                                                           
      XNOH=XNODEP                                                           
      XNODEP=ACTAN(ALFDP,BETDP)                                             
      IF(DABS(XNOH-XNODEP) .GT. PI) THEN                                    
         IF(XNODEP .LT. XNOH) THEN                                          
             XNODEP=XNODEP+TWOPI                                            
         ELSE                                                               
             XNODEP=XNODEP-TWOPI                                            
         ENDIF                                                              
      ENDIF                                                                 
      XMAP=XMAP+PL                                                          
      OMEGAP = XLS-XMAP-COSIP*XNODEP                                        
      RETURN                                                                
                                                                            
      END                                                                   
*     DSCOM  DSPACE COMMON   (STANDALONE SGP4 /DSCOM4)  16OCT90             
                                                                            
      SUBROUTINE DSCOM                                                      
                                                                            
*-----------------------------------------------------------------------    
*     THIS SUBROUTINE PROVIDES DEEP SPACE COMMON ITEMS USED BY BOTH THE     
*     SECULAR AND PERIODICS SUBROUTINES. INPUT IS PROVIDED THROUGH THE      
*     ELT,ELTM, AND EPELM COMMONS. OUTPUT ITEMS ARE PROVIDED THROUGH THE    
*     LSCOM COMMON.                                                         
*-----------------------------------------------------------------------    
                                                                            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                                   
      save  !required for IRIX compilers
                                                                            
      INTEGER YR                                                            
      INTEGER*4 SATN                                                        
                                                                            
      COMMON/ELT/R,TC,X,Y,Z,XDOT,YDOT,ZDOT                                  
      COMMON/ELTM/AM,EM,XINCM,XNODEM,OMEGAM,XMAM,CNODM,CON49,COSIM,         
     1       COSOMM,EMSQ,RTEMSQ,SINIM,SINOMM,SNODM,XN                       
      COMMON/EPELM/AO,EO,XINCO,XNODEO,OMEGAO,XMAO,AINV,BSTAR,CNDOT,         
     1       CON41,CON42,COSIO,COSIO2,EINV,EOSQ,EPOCH,OMEOSQ,          
     2       OMGDT,POSQ,QO,RTEOSQ,SINIO,T,THGRO,XMDOT,XNDOT,         
     3       XNO,XNODOT,XPIDOT,SATN,YR,init,method
                                                                            
************************************************************************    
                                                                            
      COMMON/LSCOM/S1,S2,S3,S4,S5,S6,S7,Z1,Z2,Z3,Z11,Z12,Z13,Z21,Z22,       
     1             Z23,Z31,Z32,Z33,SS1,SS2,SS3,SS4,SS5,SS6,SS7,SZ1,SZ2,     
     2             SZ3,SZ11,SZ12,SZ13,SZ21,SZ22,SZ23,SZ31,SZ32,SZ33,        
     3             DAY,GAM                                                  
                                                                            
      DATA              C1SS,          C1L,           ZCOSIS/               
     1                  2.9864797D-6,  4.7968065D-7, .91744867D0/           
      DATA              ZSINIS,        ZSINGS,        ZCOSGS/               
     1                  .39785416D0,   -.98088458D0,  .1945905D0/           
                                                                            
*     DEEP SPACE INITIALIZATION                                             
                                                                            
      LSFLG=0                                                               
      EMSQ=EM*EM                                                            
      BETASQ=1.D0-EMSQ                                                      
      RTEMSQ=SQRT(BETASQ)                                                   
                                                                            
*     INITIALIZE LUNAR SOLAR TERMS                                          
                                                                            
      DAY=EPOCH+18261.5D0+TC/1440.D0                                        
      XNODCE=FMOD2P(4.5236020D0-9.2422029D-4*DAY)                           
      STEM=SIN (XNODCE)                                                     
      CTEM=COS (XNODCE)                                                     
      ZCOSIL=.91375164D0-.03568096D0*CTEM                                   
      ZSINIL=SQRT (1.D0-ZCOSIL*ZCOSIL)                                      
      ZSINHL= .089683511D0*STEM/ZSINIL                                      
      ZCOSHL=SQRT (1.D0-ZSINHL*ZSINHL)                                      
      GAM=5.8351514D0+.0019443680D0*DAY                                     
      ZX= .39785416D0*STEM/ZSINIL                                           
      ZY= ZCOSHL*CTEM+0.91744867D0*ZSINHL*STEM                              
      ZX=ACTAN(ZX,ZY)                                                       
      ZX=GAM+ZX-XNODCE                                                      
      ZCOSGL=COS (ZX)                                                       
      ZSINGL=SIN (ZX)                                                       
                                                                            
*     DO SOLAR TERMS                                                        
                                                                            
      ZCOSG=ZCOSGS                                                          
      ZSING=ZSINGS                                                          
      ZCOSI=ZCOSIS                                                          
      ZSINI=ZSINIS                                                          
      ZCOSH=CNODM                                                           
      ZSINH=SNODM                                                           
      CC=C1SS                                                               
      XNOI=1.D0/XN                                                          
   20 A1=ZCOSG*ZCOSH+ZSING*ZCOSI*ZSINH                                      
      A3=-ZSING*ZCOSH+ZCOSG*ZCOSI*ZSINH                                     
      A7=-ZCOSG*ZSINH+ZSING*ZCOSI*ZCOSH                                     
      A8=ZSING*ZSINI                                                        
      A9=ZSING*ZSINH+ZCOSG*ZCOSI*ZCOSH                                      
      A10=ZCOSG*ZSINI                                                       
      A2= COSIM*A7+ SINIM*A8                                                
      A4= COSIM*A9+ SINIM*A10                                               
      A5=- SINIM*A7+ COSIM*A8                                               
      A6=- SINIM*A9+ COSIM*A10                                              
                                                                            
      X1=A1*COSOMM+A2*SINOMM                                                
      X2=A3*COSOMM+A4*SINOMM                                                
      X3=-A1*SINOMM+A2*COSOMM                                               
      X4=-A3*SINOMM+A4*COSOMM                                               
      X5=A5*SINOMM                                                          
      X6=A6*SINOMM                                                          
      X7=A5*COSOMM                                                          
      X8=A6*COSOMM                                                          
                                                                            
      Z31=12.D0*X1*X1-3.D0*X3*X3                                            
      Z32=24.D0*X1*X2-6.D0*X3*X4                                            
      Z33=12.D0*X2*X2-3.D0*X4*X4                                            
      Z1=3.D0*(A1*A1+A2*A2)+Z31*EMSQ                                        
      Z2=6.D0*(A1*A3+A2*A4)+Z32*EMSQ                                        
      Z3=3.D0*(A3*A3+A4*A4)+Z33*EMSQ                                        
      Z11=-6.D0*A1*A5+EMSQ *(-24.D0*X1*X7-6.D0*X3*X5)                       
      Z12=-6.D0*(A1*A6+A3*A5)+EMSQ *(-24.D0*(X2*X7+X1*X8)-6.D0*(X3*X6+X4    
     1         *X5))                                                        
      Z13=-6.D0*A3*A6+EMSQ *(-24.D0*X2*X8-6.D0*X4*X6)                       
      Z21=6.D0*A2*A5+EMSQ *(24.D0*X1*X5-6.D0*X3*X7)                         
      Z22=6.D0*(A4*A5+A2*A6)+EMSQ *(24.D0*(X2*X5+X1*X6)-6.D0*(X4*X7+X3      
     1         *X8))                                                        
      Z23=6.D0*A4*A6+EMSQ *(24.D0*X2*X6-6.D0*X4*X8)                         
      Z1=Z1+Z1+BETASQ*Z31                                                   
      Z2=Z2+Z2+BETASQ*Z32                                                   
      Z3=Z3+Z3+BETASQ*Z33                                                   
      S3=CC*XNOI                                                            
      S2=-.5D0*S3/RTEMSQ                                                    
      S4=S3*RTEMSQ                                                          
      S1=-15.D0*EM*S4                                                       
      S5=X1*X3+X2*X4                                                        
      S6=X2*X3+X1*X4                                                        
      S7=X2*X4-X1*X3                                                        
      IF(LSFLG.EQ.1) GO TO 40                                               
                                                                            
*     DO LUNAR TERMS                                                        
                                                                            
      SS1=S1                                                                
      SS2=S2                                                                
      SS3=S3                                                                
      SS4=S4                                                                
      SS5=S5                                                                
      SS6=S6                                                                
      SS7=S7                                                                
      SZ1=Z1                                                                
      SZ2=Z2                                                                
      SZ3=Z3                                                                
      SZ11=Z11                                                              
      SZ12=Z12                                                              
      SZ13=Z13                                                              
      SZ21=Z21                                                              
      SZ22=Z22                                                              
      SZ23=Z23                                                              
      SZ31=Z31                                                              
      SZ32=Z32                                                              
      SZ33=Z33                                                              
      ZCOSG=ZCOSGL                                                          
      ZSING=ZSINGL                                                          
      ZCOSI=ZCOSIL                                                          
      ZSINI=ZSINIL                                                          
      ZCOSH=ZCOSHL*CNODM+ZSINHL*SNODM                                       
      ZSINH=SNODM*ZCOSHL-CNODM*ZSINHL                                       
      CC=C1L                                                                
      LSFLG=1                                                               
      GO TO 20                                                              
   40 RETURN                                                                
                                                                            
      END                                                                   
*      DSPACE  DEEP SPACE SECULAR (STANDALONE SGP4/DSPACE4) 19SEP90         
                                                                            
      SUBROUTINE DSPACE(DNDT,DEDT,DIDT,DNODT,DOMDT,DMDT,INITDS)             
                                                                            
*-----------------------------------------------------------------------    
*     THIS SUBROUTINE PROVIDES DEEP SPACE CONTRIBUTIONS TO MEAN ELEMENTS    
*     FOR PERTURBING THIRD BODY, THESE EFFECTS HAVE BEEN AVERAGED OVER      
*     ONE REVOLUTION OF THE MOON AND SUN. FOR EARTH RESONANCE EFFECTS,      
*     THESE EFFECTS HAVE BEEN AVERAGED OVER N REVOLUTIONS OF THE            
*     SATELLITE. (N = MEAN MOTION)                                          
*-----------------------------------------------------------------------    
                                                                            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                                   
      save  !required for IRIX compilers
                                                                            
      INTEGER YR                                                            
      INTEGER*4 SATN                                                        
                                                                            
      COMMON/CONST/C1,C1P2P,PI,PIO2,QZMS2T,RPTIM,SS,THGR70,TWOPI,X2O3,      
     1       X3PIO2,XJ2,XJ3,XJ4,XKE,XKMPER,XJ3OJ2                           
      COMMON/ELT/R,TC,X,Y,Z,XDOT,YDOT,ZDOT                                  
      COMMON/ELTM/AM,EM,XINCM,XNODEM,OMEGAM,XMAM,CNODM,CON49,COSIM,         
     1       COSOMM,EMSQ,RTEMSQ,SINIM,SINOMM,SNODM,XN                       
      COMMON/EPELM/AO,EO,XINCO,XNODEO,OMEGAO,XMAO,AINV,BSTAR,CNDOT,         
     1       CON41,CON42,COSIO,COSIO2,EINV,EOSQ,EPOCH,OMEOSQ,          
     2       OMGDT,POSQ,QO,RTEOSQ,SINIO,T,THGRO,XMDOT,XNDOT,         
     3       XNO,XNODOT,XPIDOT,SATN,YR,init,method
                                                                            
************************************************************************    
                                                                            
      COMMON/LSCOM/S1,S2,S3,S4,S5,S6,S7,Z1,Z2,Z3,Z11,Z12,Z13,Z21,Z22,       
     1             Z23,Z31,Z32,Z33,SS1,SS2,SS3,SS4,SS5,SS6,SS7,SZ1,SZ2,     
     2             SZ3,SZ11,SZ12,SZ13,SZ21,SZ22,SZ23,SZ31,SZ32,SZ33,        
     3             DAY,GAM                                                  
                                                                            
      DATA              ZNS,           ZNL/                                 
     1                  1.19459D-5,    1.5835218D-4/                        
                                                                            
*     DEEP SPACE INITIALIZATION                                             
                                                                            
      IF(INITDS .GT. 0) GO TO 100                                           
                                                                            
      IREZ=0                                                                
      IF(XN.LT.(.0052359877D0).AND.XN.GT.(.0034906585D0)) IREZ=1            
      IF(XN.GE.(8.26D-3).AND.XN.LE.(9.24D-3).AND.EM.GE..5D0) IREZ=2         
                                                                            
*     DO SOLAR TERMS                                                        
                                                                            
      SES=SS1*ZNS*SS5                                                       
      SIS=SS2*ZNS*(SZ11+SZ13)                                               
      SLS=-ZNS*SS3*(SZ1+SZ3-14.D0-6.D0*EMSQ)                                
      SGHS=SS4*ZNS*(SZ31+SZ33-6.D0)                                         
      SHS=-ZNS*SS2*(SZ21+SZ23)                                              
      IF(XINCM.LT.5.2359877D-2) SHS=0.D0                                    
      IF(SINIM .NE. 0.D0) SHS=SHS/SINIM                                     
      SGS=SGHS-COSIM*SHS                                                    
                                                                            
*     DO LUNAR TERMS                                                        
                                                                            
      DEDT=SES+S1*ZNL*S5                                                    
      DIDT=SIS+S2*ZNL*(Z11+Z13)                                             
      DMDT=SLS-ZNL*S3*(Z1+Z3-14.D0-6.D0*EMSQ)                               
      SGHL=S4*ZNL*(Z31+Z33-6.D0)                                            
      SHL=-ZNL*S2*(Z21+Z23)                                                 
      IF(XINCM.LT.5.2359877D-2) SHL=0.D0                                    
      DOMDT=SGS+SGHL                                                        
      DNODT=SHS                                                             
      IF(SINIM .NE. 0.D0) THEN                                              
          DOMDT=DOMDT-COSIM/SINIM*SHL                                       
          DNODT=DNODT+SHL/SINIM                                             
      END IF                                                                
                                                                            
*     CALCULATE DEEP SPACE RESONANCE EFFECTS                                
                                                                            
  100 DNDT=0.D0                                                             
      THETA=FMOD2P(THGRO+TC*RPTIM)                                          
      EM=EM+DEDT*T                                                          
      XINCM=XINCM+DIDT*T                                                    
      OMEGAM=OMEGAM+DOMDT*T                                                 
      XNODEM=XNODEM+DNODT*T                                                 
      XMAM=XMAM+DMDT*T                                                      
         IF(XINCM .LT. 0.D0) THEN                                           
           XINCM=-XINCM                                                     
           OMEGAM=OMEGAM-PI                                                 
           XNODEM=XNODEM+PI                                                 
         END IF                                                             
      IF(IREZ .EQ. 0) GO TO 999                                             
      CALL SREZ(DNDT,DNODT,DOMDT,DMDT,THETA,IREZ)                           
      XN=XNO+DNDT                                                           
                                                                            
  999 RETURN                                                                
                                                                            
      END                                                                   
*     MODULO BY TWO PI   (STANDALONE SGP4/FMOD2P4)     19SEP90              
                                                                            
      FUNCTION FMOD2P(X)                                                    
                                                                            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                                   
                                                                            
************************************************************************    
                                                                            
      COMMON/CONST/C1,C1P2P,PI,PIO2,QZMS2T,RPTIM,SS,THGR70,TWOPI,X2O3,      
     1       X3PIO2,XJ2,XJ3,XJ4,XKE,XKMPER,XJ3OJ2                           
                                                                            
      FMOD2P=X                                                              
      I=FMOD2P/TWOPI                                                        
      FMOD2P=FMOD2P-I*TWOPI                                                 
      IF(FMOD2P.LT.0.D0) FMOD2P=FMOD2P+TWOPI                                
      RETURN                                                                
      END                                                                   
*  INITL INITIALIZES PROPAGATORS (STANDALONE SGP4/INITL4) 19SEP90           
                                                                            
      SUBROUTINE INITL                                                      
                                                                            
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)                                    
      save  !required for IRIX compilers
                                                                            
************************************************************************    
                                                                            
      INTEGER YR                                                            
      INTEGER*4 SATN                                                        
                                                                            
      COMMON/CONST/C1,C1P2P,PI,PIO2,QZMS2T,RPTIM,SS,THGR70,TWOPI,X2O3,      
     1       X3PIO2,XJ2,XJ3,XJ4,XKE,XKMPER,XJ3OJ2                           
      COMMON/EPELM/AO,EO,XINCO,XNODEO,OMEGAO,XMAO,AINV,BSTAR,CNDOT,         
     1       CON41,CON42,COSIO,COSIO2,EINV,EOSQ,EPOCH,OMEOSQ,          
     2       OMGDT,POSQ,QO,RTEOSQ,SINIO,T,THGRO,XMDOT,XNDOT,         
     3       XNO,XNODOT,XPIDOT,SATN,YR,init,method
                                                                            
      DATA FK5R/5.07551419432269442D-15/                                    
                                                                            
*     CALCULATE AUXILLARY EPOCH QUANTITIES                                  
      EOSQ=EO*EO                                                            
      OMEOSQ=1.D0-EOSQ                                                      
      RTEOSQ=SQRT(OMEOSQ)                                                   
      COSIO=COS(XINCO)                                                      
      COSIO2=COSIO*COSIO                                                    
                                                                            
*     UN-KOZAI THE MEAN MOTION *                                            
      AK = (XKE/XNO)**X2O3                                                  
      D1 = .75D0*XJ2*(3.D0*COSIO2-1.D0)/(RTEOSQ*OMEOSQ)                     
      DEL = D1/(AK*AK)                                                      
      ADEL = AK*(1.D0-DEL*DEL-DEL*(1.D0/3.D0+134.D0*DEL*DEL/81.D0))         
      DEL = D1/(ADEL*ADEL)                                                  
      XNO = XNO/(1.D0 + DEL)                                                
                                                                            
      AO=(XKE/XNO)**X2O3                                                    
      SINIO=SIN(XINCO)                                                      
      PO=AO*OMEOSQ                                                          
      CON42=1.D0-5.D0*COSIO2                                                
      CON41=-CON42-COSIO2-COSIO2                                            
      AINV=1.D0/AO                                                          
      EINV=1.D0/EO                                                          
      POSQ=PO*PO                                                            
      QO=AO*(1.D0-EO)                                                       
      METHOD=0                                                              
      IF(QO .LT. 1.D0) WRITE(6,950) SATN                                    
                                                                            
*     CALCULATE NUMBER OF INTEGER DAYS SINCE 0 JAN 1970.                    
                                                                            
      IF(YR .LT. 69) GO TO 900                                              
      TS70=EPOCH-7305.D0                                                    
      IDS70=TS70 + 1.D-8                                                    
      DS70=IDS70                                                            
      TFRAC=TS70-DS70                                                       
                                                                            
*     CALCULATE GREENWICH LOCATION AT EPOCH                                 
                                                                            
      THGR=FMOD2P(THGR70+C1*DS70+C1P2P*TFRAC+TS70*TS70*FK5R)                
      THGRO=FMOD2P(THGR)                                                    
                                                                            
      RETURN                                                                
                                                                            
  900 WRITE(6,925)                                                          
  925 FORMAT('0',////,' *****   UNABLE TO COMPUTE GREENWICH SIDEREAL TIM    
     *E AT EPOCH   *****',/,' *****   EPOCH YEAR MUST BE 1969 OR LATER -    
     *- CANNOT CONTINUE   *****')                                           
  950 FORMAT ('0*** SATN',I6,' EPOCH ELTS SUB-ORBITAL ***')                 
      END                                                                   
*      SREZ   SGP4 RESONANCE (STANDALONE SGP4/SREZ4)  15OCT90
                                                                            
      SUBROUTINE SREZ(DNDT,DNODT,DOMDT,DMDT,THETA,IREZ)                     
                                                                            
*-----------------------------------------------------------------------    
*                                                                           
*     THIS SUBROUTINE PROVIDES DEEP SPACE CONTRIBUTIONS TO MEAN MOTION      
*     DOT DUE TO GEOPOTENTIAL RESONANCE WITH HALF DAY AND ONE DAY ORBITS    
*                                                                           
*     IREZ=1     ONE DAY RESONANCE                                          
*     IREZ=2     HALF DAY RESONANCE                                         
*                                                                           
*-----------------------------------------------------------------------    
                                                                            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                                   
      save  !required for IRIX compilers
                                                                            
      INTEGER YR                                                            
      INTEGER*4 SATN                                                        
                                                                            
      COMMON/CONST/C1,C1P2P,PI,PIO2,QZMS2T,RPTIM,SS,THGR70,TWOPI,X2O3,      
     1       X3PIO2,XJ2,XJ3,XJ4,XKE,XKMPER,XJ3OJ2                           
      COMMON/ELTM/AM,EM,XINCM,XNODEM,OMEGAM,XMAM,CNODM,CON49,COSIM,         
     1       COSOMM,EMSQ,RTEMSQ,SINIM,SINOMM,SNODM,XN                       
      COMMON/EPELM/AO,EO,XINCO,XNODEO,OMEGAO,XMAO,AINV,BSTAR,CNDOT,         
     1       CON41,CON42,COSIO,COSIO2,EINV,EOSQ,EPOCH,OMEOSQ,          
     2       OMGDT,POSQ,QO,RTEOSQ,SINIO,T,THGRO,XMDOT,XNDOT,         
     3       XNO,XNODOT,XPIDOT,SATN,YR,init,method
                                                                            
************************************************************************    
                                                                            
      DATA Q22,Q31,Q33/1.7891679D-6,2.1460748D-6,2.2123015D-7/              
      DATA G22,G32/5.7686396D0,0.95240898D0/                                
      DATA G44,G52/1.8014998D0,1.0508330D0/                                 
      DATA G54/4.4108898D0/                                                 
      DATA ROOT22,ROOT32/1.7891679D-6,3.7393792D-7/                         
      DATA ROOT44,ROOT52/7.3636953D-9,1.1428639D-7/                         
      DATA ROOT54/2.1765803D-9/                                             
                                                                            
*     BRANCH TO INTEGRATOR IF NOT INITIALIZING                              
                                                                            
      IF(INIT .EQ. 0) GO TO 350                                             
      AONV=(XN/XKE)**X2O3                                                   
      IF(IREZ .EQ. 1) GO TO 70                                              
                                                                            
*     GEOPOTENTIAL RESONANCE FOR 12 HOUR ORBITS                             
                                                                            
      COSISQ=COSIM*COSIM                                                    
      EOC=EO*EOSQ    !  V3.01                                               
      G201=-.306D0-(EO-.64D0)*.440D0   !  V3.01                             
      IF(EO.GT.(.65D0)) GO TO 45   !  V3.01                                 
      G211=3.616D0-13.247D0*EO+16.290D0*EOSQ   !  V3.01                     
      G310=-19.302D0+117.390D0*EO-228.419D0*EOSQ+156.591D0*EOC  !  V3.01    
      G322=-18.9068D0+109.7927D0*EO-214.6334D0*EOSQ+146.5816D0*EOC  !  V3.01
      G410=-41.122D0+242.694D0*EO-471.094D0*EOSQ+313.953D0*EOC  !  V3.01    
      G422=-146.407D0+841.880D0*EO-1629.014D0*EOSQ+1083.435D0*EOC  !  V3.01 
      G520=-532.114D0+3017.977D0*EO-5740.032D0*EOSQ+3708.276D0*EOC  !  V3.01
      GO TO 55                                                              
   45 G211=-72.099D0+331.819D0*EO-508.738D0*EOSQ+266.724D0*EOC  !  V3.01    
      G310=-346.844D0+1582.851D0*EO-2415.925D0*EOSQ+1246.113D0*EOC  !  V3.01
      G322=-342.585D0+1554.908D0*EO-2366.899D0*EOSQ+1215.972D0*EOC !  V3.01 
      G410=-1052.797D0+4758.686D0*EO-7193.992D0*EOSQ+3651.957D0*EOC  !  V3.0
      G422=-3581.69D0+16178.11D0*EO-24462.77D0*EOSQ+12422.52D0*EOC  !  V3.01
      IF(EO.GT.(.715D0)) GO TO 50  !  V3.01                                 
      G520=1464.74D0-4664.75D0*EO+3763.64D0*EOSQ  !  V3.01                  
      GO TO 55                                                              
   50 G520=-5149.66D0+29936.92D0*EO-54087.36D0*EOSQ+31324.56D0*EOC  !  V3.01
   55 IF(EO.GE.(.7D0)) GO TO 60  !  V3.01                                   
      G533=-919.2277D0+4988.61D0*EO-9064.77D0*EOSQ+5542.21D0*EOC  !  V3.01  
      G521 = -822.71072D0+4568.6173D0*EO-8491.4146D0*EOSQ+5337.524D0*EOC!  V
      G532 = -853.666D0+4690.25D0*EO-8624.77D0*EOSQ+5341.4D0*EOC  !  V3.01  
      GO TO 65                                                              
   60 G533=-37995.78D0+161616.52D0*EO-229838.2D0*EOSQ+109377.94D0*EOC !  V3.
      G521 = -51752.104D0+218913.95D0*EO-309468.16D0*EOSQ+146349.42D0       
     1         *EOC    !  V3.01                                             
      G532 = -40023.88D0+170470.89D0*EO-242699.48D0*EOSQ+115605.82D0*EOC !  
   65 SINI2=SINIM*SINIM                                                     
      F220=.75D0*(1.D0+2.D0*COSIM+COSISQ)                                   
      F221=1.5D0*SINI2                                                      
      F321=1.875D0*SINIM*(1.D0-2.D0*COSIM-3.D0*COSISQ)                      
      F322=-1.875D0*SINIM*(1.D0+2.D0*COSIM-3.D0*COSISQ)                     
      F441=35.D0*SINI2*F220                                                 
      F442=39.3750D0*SINI2*SINI2                                            
      F522=9.84375D0*SINIM*(SINI2*(1.D0-2.D0*COSIM-5.D0*COSISQ)             
     1     +.33333333D0*(-2.D0+4.D0*COSIM+6.D0*COSISQ))                     
      F523 = SINIM*(4.92187512D0*SINI2*(-2.D0-4.D0*COSIM+10.D0*COSISQ)      
     1      +6.56250012D0*(1.D0+2.D0*COSIM-3.D0*COSISQ))                    
      F542 = 29.53125D0*SINIM*(2.D0-8.D0*COSIM+COSISQ*(-12.D0+8.D0*COSIM    
     1      +10.D0*COSISQ))                                                 
      F543=29.53125D0*SINIM*(-2.D0-8.D0*COSIM+COSISQ*(12.D0+8.D0*COSIM      
     1         -10.D0*COSISQ))                                              
      XNO2=XN*XN                                                            
      AINV2=AONV*AONV                                                       
      TEMP1 = 3.D0*XNO2*AINV2                                               
      TEMP = TEMP1*ROOT22                                                   
      D2201 = TEMP*F220*G201                                                
      D2211 = TEMP*F221*G211                                                
      TEMP1 = TEMP1*AONV                                                    
      TEMP = TEMP1*ROOT32                                                   
      D3210 = TEMP*F321*G310                                                
      D3222 = TEMP*F322*G322                                                
      TEMP1 = TEMP1*AONV                                                    
      TEMP = 2.D0*TEMP1*ROOT44                                              
      D4410 = TEMP*F441*G410                                                
      D4422 = TEMP*F442*G422                                                
      TEMP1 = TEMP1*AONV                                                    
      TEMP = TEMP1*ROOT52                                                   
      D5220 = TEMP*F522*G520                                                
      D5232 = TEMP*F523*G532                                                
      TEMP = 2.D0*TEMP1*ROOT54                                              
      D5421 = TEMP*F542*G521                                                
      D5433 = TEMP*F543*G533                                                
      XLAMO = FMOD2P(XMAO+XNODEO+XNODEO-THETA-THETA)                        
      GO TO 80                                                              
                                                                            
*      SYNCHRONOUS RESONANCE TERMS                                          
                                                                            
   70 G200=1.0D0+EOSQ*(-2.5D0+.8125D0*EOSQ)   !  V3.01                      
      G310=1.0D0+2.0D0*EOSQ   !  V3.01                                      
      G300=1.0D0+EOSQ*(-6.0D0+6.60937D0*EOSQ)  !  V3.01                     
      F220=.75D0*(1.D0+COSIM)*(1.D0+COSIM)                                  
      F311=.9375D0*SINIM*SINIM*(1.D0+3.D0*COSIM)-.75D0*(1.D0+COSIM)         
      F330=1.D0+COSIM                                                       
      F330=1.875D0*F330*F330*F330                                           
      DEL1=3.D0*XN*XN*AONV*AONV                                             
      DEL2=2.D0*DEL1*F220*G200*Q22                                          
      DEL3=3.D0*DEL1*F330*G300*Q33*AONV                                     
      DEL1=DEL1*F311*G310*Q31*AONV                                          
      FASX2=.13130908D0                                                     
      FASX4=2.8843198D0                                                     
      FASX6=.37448087D0                                                     
      XLAMO=FMOD2P(XMAO+XNODEO+OMEGAO-THETA)                                
      GO TO 80                                                              
                                                                            
*     FOR SGP4, INITIALIZE THE INTEGRATOR                                   
                                                                            
   80 XLI=XLAMO                                                             
      XNI=XNO                                                               
      ATIME=0.D0                                                            
      STEPP=720.D0                                                          
      STEPN=-720.D0                                                         
      STEP2=259200.D0                                                       
      IF(IREZ .EQ. 1) XFACT=XMDOT+XPIDOT-RPTIM+DMDT+DOMDT+DNODT-XNO         
      IF(IREZ .EQ. 2) XFACT=XMDOT+DMDT+2.D0*(XNODOT+DNODT-RPTIM)-XNO        
      GO TO 999                                                             
                                                                            
*     UPDATE RESONANCES - NUMERICAL (EULER-MACLAURIN) INTEGRATION           
                                                                            
  350 IF(ATIME.EQ.(0.D0)) GO TO 390                                         
      IF(T.GE.(0.D0).AND.ATIME.LT.(0.D0)) GO TO 390                         
      IF(T.LT.(0.D0).AND.ATIME.GE.(0.D0)) GO TO 390                         
  351 IF(ABS(T).GE.ABS(ATIME)) GO TO 354                                    
      IF(T.GE.(0.D0)) GO TO 352                                             
      DELT=STEPP                                                            
      GO TO 353                                                             
  352 DELT=STEPN                                                            
  353 IRET=351                                                              
      GO TO 380                                                             
  354 IF(T.GT.(0.D0)) GO TO 355                                             
      DELT=STEPN                                                            
      GO TO 356                                                             
  355 DELT=STEPP                                                            
  356 IF(ABS(T-ATIME).LT.STEPP) GO TO 360                                   
      IRET=0                                                                
      GO TO 380                                                             
  360 FT=T-ATIME                                                            
      IRETN=0                                                               
      GO TO 370                                                             
  361 XN=XNI+XNDT*FT+XNDDT*FT*FT*.5D0                                       
      XL=XLI+XLDOT*FT+XNDT*FT*FT*.5D0                                       
      IF(IREZ .EQ. 1) GO TO 362                                             
      XMAM=XL-2.D0*XNODEM+2.D0*THETA                                        
      DNDT=XN-XNO                                                           
      GO TO 999                                                             
  362 XMAM=XL-XNODEM-OMEGAM+THETA                                           
      DNDT=XN-XNO                                                           
      GO TO 999                                                             
                                                                            
*     DOT TERMS CALCULATED                                                  
                                                                            
  370 IF(IREZ .EQ. 2) GO TO 372                                             
*     NEAR - SYNCHRONOUS RESONANCE TERMS                                    
      XNDT=DEL1*SIN(XLI-FASX2)+DEL2*SIN(2.D0*(XLI-FASX4))                   
     1     +DEL3*SIN(3.D0*(XLI-FASX6))                                      
      XLDOT=XNI+XFACT                                                       
      XNDDT=DEL1*COS(XLI-FASX2)                                             
     *     +2.D0*DEL2*COS(2.D0*(XLI-FASX4))                                 
     *     +3.D0*DEL3*COS(3.D0*(XLI-FASX6))                                 
      XNDDT=XNDDT*XLDOT                                                     
      GO TO 374                                                             
*     NEAR - HALF-DAY RESONANCE TERMS                                       
  372 XOMI=OMEGAO+OMGDT*ATIME                                               
      X2OMI=XOMI+XOMI                                                       
      X2LI=XLI+XLI                                                          
      XNDT=D2201*SIN(X2OMI+XLI-G22)                                         
     *     +D2211*SIN(XLI-G22)                                              
     *     +D3210*SIN(XOMI+XLI-G32)                                         
     *     +D3222*SIN(-XOMI+XLI-G32)                                        
     *     +D4410*SIN(X2OMI+X2LI-G44)                                       
     *     +D4422*SIN(X2LI-G44)                                             
     *     +D5220*SIN(XOMI+XLI-G52)                                         
     *     +D5232*SIN(-XOMI+XLI-G52)                                        
     *     +D5421*SIN(XOMI+X2LI-G54)                                        
     *     +D5433*SIN(-XOMI+X2LI-G54)                                       
      XLDOT=XNI+XFACT                                                       
      XNDDT=D2201*COS(X2OMI+XLI-G22)                                        
     *     +D2211*COS(XLI-G22)                                              
     *     +D3210*COS(XOMI+XLI-G32)                                         
     *     +D3222*COS(-XOMI+XLI-G32)                                        
     *     +D5220*COS(XOMI+XLI-G52)                                         
     *     +D5232*COS(-XOMI+XLI-G52)                                        
     *     +2.D0*(D4410*COS(X2OMI+X2LI-G44)                                 
     *         +D4422*COS(X2LI-G44)                                         
     *         +D5421*COS(XOMI+X2LI-G54)                                    
     *         +D5433*COS(-XOMI+X2LI-G54))                                  
      XNDDT=XNDDT*XLDOT                                                     
                                                                            
  374 CONTINUE                                                              
      IF(IRETN.EQ.381) GO TO 381                                            
      GO TO 361                                                             
                                                                            
*     INTEGRATOR                                                            
                                                                            
  380 IRETN=381                                                             
      GO TO 370                                                             
  381 XLI=XLI+XLDOT*DELT+XNDT*STEP2                                         
      XNI=XNI+XNDT*DELT+XNDDT*STEP2                                         
      ATIME=ATIME+DELT                                                      
      IF(IRET.EQ.351) GO TO 351                                             
      GO TO 356                                                             
                                                                            
*     EPOCH RESTART                                                         
                                                                            
  390 IF(T.GE.(0.D0)) GO TO 391                                             
      DELT=STEPN                                                            
      GO TO 392                                                             
  391 DELT=STEPP                                                            
  392 ATIME=0.D0                                                            
      XNI=XNO                                                               
      XLI=XLAMO                                                             
      GO TO 356                                                             
                                                                            
  999 RETURN                                                                
      END                                                                   
